## BMR HC 64 API, modbus TCP

See [pyModbusTCP](http://pythonhosted.org/pyModbusTCP/) documentation.

BMC HC 64 modbus TCP answers on port 502.

The specification was kindly provided by Martin Kadlec from BMR company.

## ModBus communication

### Packet, reading

|Function        | Address (2 B) | Number of registers |
|----------------|---------------|---------------------|
| 3 (read)       | HiB + LoB     | 0, 1..7             |

### Packet, a reading response

|Function | # bytes | Data (2xN bytes) |
| 3 (read)| 2xN     | Byte 1, Byte 2, Byte 3, ... |
| 0x83    | 1..4    | 1 unknown function, 2 wrong address, 3 wrong # of registers, 4 runtime error |

### Packet, writing

| Function | Address | Number of registers | # of bytes | Data (2xN bytes) |
|----------|---------|---------------------|------------|------------------|
| 16       | Start addr Hi, Start Addr Lo | 0, 1..7 (N)|2xN bytes |

### Packet, a writing response

| Function | Address | # of registers |
| 3 (OK)   | Start Hi, Start Lo | 0, 1..7 (N) |
| 0x83     | 1..4 (1: unknown error, 2: address error, 3: number of registers error, 4: runtime error) |

## Registers

| Class | Objects | Registers | Address |
|-------|---------|-----------|---------|
|Circuits         | 32 | 25 |    0 |
|Groups           | 16 | 28 |  800 |
|Mode             | 32 | 23 | 1248 |
|Service          |  1 | 17 | 1984 |
|Web login        |  1 | 14 | 2001 |
|WTR01            |  1 |  2 | 2015 |
|LOW              |  1 |  8 | 2017 |
|Unit             |  1 |  2 | 2025 |
|Time, date       |  1 |  3 | 2027 |
|Info WTR\_01     |  1 |  2 | 2030 |
|Room info        | 32 |  6 | 2032 |
|End elements     |  8 |  2 | 2224 |
|Service\_1)      |  1 |  6 | 2240 |
|Switch modules   |  1 |  4 | 2246 |
|Blinds service   |  1 | 27 | 2250 |
|Blinds           | 32 | 17 | 2277 |
|Blinds modes     |  8 | 15 | 2821 |
|Central          |  1 |  2 | 2941 |
|Blinds info      | 32 |  5 | 2943 |
|Service\_2       |  1 |  7 | 3103 |
|Heat recovery    |  1 | 19 | 3110 |
|Rezimy           |  8 | 23 | 3129 |
|Transitions      |  1 |  4 | 3313 |
|Global KC        |  2 |  2 | 3317 |
|CO2 sensor       |  8 |  5 | 3321 |
|End of HC\_reg   |    |    | 3361 |
|Ventilation time |  8 |  8 | 3800 |
